#################################################################################
# The code below assume all other code related to the application has run 
# smoothly and all objects created therein are in memory
#################################################################################

# generalized ridge
# calculate QDA scores
qdaCgr <- numeric()
qdaMgr <- numeric()
for (i in 1:nrow(Y0)){
	qdaCgr <- c(qdaCgr, Y0[i,,drop=FALSE] %*% Pcnt %*% t(Y0[i,,drop=FALSE]) - Y0[i,,drop=FALSE] %*% Pmwt %*% t(Y0[i,,drop=FALSE]))
}
for (i in 1:nrow(Y1)){
	qdaMgr <- c(qdaMgr, Y1[i,,drop=FALSE] %*% Pcnt %*% t(Y1[i,,drop=FALSE]) - Y1[i,,drop=FALSE] %*% Pmwt %*% t(Y1[i,,drop=FALSE]))
}
xlimsGR <- c(min(qdaC, qdaM), max(qdaC, qdaM))
hist(qdaCgr, n=25, xlim=xlimsGR, col="lightgreen", border="darkgreen", xlab="QDA score", main="Generalized ridge")
hist(qdaMgr, n=25, col="pink", border="purple", add=TRUE)
legend("topright", c("cancer", "metastatis"), fill=c("lightgreen", "pink"), border=c("darkgreen", "purple"))

#################################################################################

# regular ridge
# calculate QDA scores
qdaCrr <- numeric()
qdaMrr <- numeric()
for (i in 1:nrow(Y0)){
	qdaCrr <- c(qdaCrr, Y0[i,,drop=FALSE] %*% PplainC %*% t(Y0[i,,drop=FALSE]) - Y0[i,,drop=FALSE] %*% PplainM %*% t(Y0[i,,drop=FALSE]))
}
for (i in 1:nrow(Y1)){
	qdaMrr <- c(qdaMrr, Y1[i,,drop=FALSE] %*% PplainC %*% t(Y1[i,,drop=FALSE]) - Y1[i,,drop=FALSE] %*% PplainM %*% t(Y1[i,,drop=FALSE]))
}
xlimsRR <- c(min(qdaCrr, qdaMrr), max(qdaCrr, qdaMrr))
hist(qdaCrr, n=25, xlim=xlimsRR, col="lightgreen", border="darkgreen", xlab="QDA score", main="Regular ridge", ylim=c(0,12))
hist(qdaMrr, n=25, col="pink", border="purple", add=TRUE)
legend("topright", c("cancer", "metastatis"), fill=c("lightgreen", "pink"), border=c("darkgreen", "purple"))

#################################################################################

# Chordal support ridge
# calculate QDA scores
qdaCcr <- numeric()
qdaMcr <- numeric()
for (i in 1:nrow(Y0)){
	qdaCcr <- c(qdaCcr, Y0[i,,drop=FALSE] %*% PzerosC %*% t(Y0[i,,drop=FALSE]) - Y0[i,,drop=FALSE] %*% PzerosM %*% t(Y0[i,,drop=FALSE]))
}
for (i in 1:nrow(Y1)){
	qdaMcr <- c(qdaMcr, Y1[i,,drop=FALSE] %*% PzerosC %*% t(Y1[i,,drop=FALSE]) - Y1[i,,drop=FALSE] %*% PzerosM %*% t(Y1[i,,drop=FALSE]))
}
xlimsCR <- c(min(qdaCcr, qdaMcr), max(qdaCcr, qdaMcr))
hist(qdaCcr, n=25, xlim=xlimsCR, col="lightgreen", border="darkgreen", xlab="QDA score", main="Chordal ridge")
hist(qdaMcr, n=25, col="pink", border="purple", add=TRUE)
legend("topright", c("cancer", "metastatis"), fill=c("lightgreen", "pink"), border=c("darkgreen", "purple"))






